# ================================================================================
# (c) 2011 Altera Corporation. All rights reserved.
# Altera products are protected under numerous U.S. and foreign patents, maskwork
# rights, copyrights and other intellectual property laws.
# 
# This reference design file, and your use thereof, is subject to and governed
# by the terms and conditions of the applicable Altera Reference Design License
# Agreement (either as signed by you, agreed by you upon download or as a
# "click-through" agreement upon installation andor found at www.altera.com).
# By using this reference design file, you indicate your acceptance of such terms
# and conditions between you and Altera Corporation.  In the event that you do
# not agree with such terms and conditions, you may not use the reference design
# file and please promptly destroy any copies you have made.
# 
# This reference design file is being provided on an "as-is" basis and as an
# accommodation and therefore all warranties, representations or guarantees of
# any kind (whether express, implied or statutory) including, without limitation,
# warranties of merchantability, non-infringement, or fitness for a particular
# purpose, are specifically disclaimed.  By making this reference design file
# available, Altera expressly does not recommend, suggest or require that this
# reference design file be used in combination with any other product not
# provided by Altera.
# ================================================================================
# 
# Modified simulation script for the "Simulating Designs with Lower-Level Qsys Systems" Guide
# Jeff Wiencrot - 8/2/2011
# 
# This file demonstrates the modifications to the automatically generated simulation
# that are necessary to accomodate designs in which the Qsys system is not the top level
# entity.  The modifications are marked and explained below with "CHANGE" comments.
# 
# This file replaces the automatically generated testbench file which for this guide is
# located in:
#    <project directory>/niosii_system/testbench/niosii_system_tb/simulation/
# 
# In general, this file will be located in:
#    <project directory>/<Qsys system name>/testbench/<Qsys system name>_tb/simulation/
#
# 
# IMPORTANT NOTE:
#
#    In the file paths throughout this script, <project directory> is set as
#        c:/lower_level_qsys/
#
#    If you are using a different project directory, use "Find & Replace" to replace
#    "c:/lower_level_qsys/" with your project directory.  This is the only file in which
#    you will need to make this change.
# 
# 
# For more information, see "lower_level_qsys.pdf"
# 
# ================================================================================



# -----------------------------------------
# Auto-generated simulation script

# -----------------------------------------
# Initialize the variable
if ![info exist SYSTEM_INSTANCE_NAME] { 
   set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
   set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
} 

if ![info exist TOP_LEVEL_NAME] { 
   set TOP_LEVEL_NAME "niosii_system_tb"
} elseif { ![ string match "" $TOP_LEVEL_NAME ] } { 
   set TOP_LEVEL_NAME "$TOP_LEVEL_NAME"
} 

if ![info exist QSYS_SIMDIR] { 
   set QSYS_SIMDIR "."
} elseif { ![ string match "" $QSYS_SIMDIR ] } { 
   set QSYS_SIMDIR "$QSYS_SIMDIR"
} 

set HIERARCHY_ABOVE_QSYS "/top_level_inst"


# -----------------------------------------
# Copy ROM/RAM files to simulation directory
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_ram.hex ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ic_tag_ram.dat ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ic_tag_ram.hex ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ic_tag_ram.mif ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ociram_default_contents.dat ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ociram_default_contents.hex ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_ociram_default_contents.mif ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_a.dat ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_a.hex ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_a.mif ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_b.dat ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_b.hex ./
file copy -force c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_rf_ram_b.mif ./
file copy -force c:/lower_level_qsys/software/hello_world_qsys_in_lower_hierachical_level_example/mem_init/hdl_sim/ram.dat ./
file copy -force c:/lower_level_qsys/software/hello_world_qsys_in_lower_hierachical_level_example/mem_init/ram.hex ./

# -----------------------------------------
# Create compilation libraries
vlib work
vmap work work
if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
vlib altera_ver
vmap altera_ver altera_ver
vlib lpm_ver
vmap lpm_ver lpm_ver
vlib sgate_ver
vmap sgate_ver sgate_ver
vlib altera_mf_ver
vmap altera_mf_ver altera_mf_ver
vlib altera_lnsim_ver
vmap altera_lnsim_ver altera_lnsim_ver
vlib cycloneiii_ver
vmap cycloneiii_ver cycloneiii_ver

}

# -----------------------------------------
# Compile device library files
alias dev_com {
if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
   vlog "C:/altera/11.0/quartus/eda/sim_lib/altera_primitives.v" -work altera_ver
   vlog "C:/altera/11.0/quartus/eda/sim_lib/220model.v" -work lpm_ver
   vlog "C:/altera/11.0/quartus/eda/sim_lib/sgate.v" -work sgate_ver
   vlog "C:/altera/11.0/quartus/eda/sim_lib/altera_mf.v" -work altera_mf_ver
   vlog -sv "C:/altera/11.0/quartus/eda/sim_lib/altera_lnsim.sv" -work altera_lnsim_ver
   vlog "C:/altera/11.0/quartus/eda/sim_lib/cycloneiii_atoms.v" -work cycloneiii_ver
}

}

# -----------------------------------------
# Compile the design files in correct order
alias com {
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_irq_mapper.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_arbitrator.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_rsp_xbar_mux_001.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_arbitrator.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_rsp_xbar_mux.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_rsp_xbar_demux_002.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_rsp_xbar_demux.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_arbitrator.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_cmd_xbar_mux.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_cmd_xbar_demux_001.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_cmd_xbar_demux.sv"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_reset_controller.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_reset_synchronizer.v"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_traffic_limiter.sv"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_avalon_st_pipeline_base.v"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_id_router_002.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_id_router.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_addr_router_001.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_addr_router.sv"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_avalon_sc_fifo.v"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_slave_agent.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_burst_uncompressor.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_master_agent.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_slave_translator.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_merlin_master_translator.sv"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_output_pio.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_jtag_uart.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_ram.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2.vo"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_jtag_debug_module_sysclk.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_jtag_debug_module_tck.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_jtag_debug_module_wrapper.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_mult_cell.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_oci_test_bench.v"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_nios2_test_bench.v"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/verbosity_pkg.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst_output_pio_bfm.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/verbosity_pkg.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_avalon_reset_source.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/verbosity_pkg.sv"
   vlog -sv "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/altera_avalon_clock_source.sv"
   vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/submodules/niosii_system_tb_niosii_system_inst.v"

	# CHANGE: compile additional design files after the Qsys system, before the test bench
	
	vlog "c:/lower_level_qsys/counter.v"
	vlog "c:/lower_level_qsys/top_level.v"
	
	# END CHANGE
	
	vlog "c:/lower_level_qsys/niosii_system/testbench/niosii_system_tb/simulation/niosii_system_tb.v"
}


# CHANGE: add the hierarchy above the Qsys system before $SYSTEM_INSTANCE_NAME.
# DO NOT put a slash between the added hierachy and the $SYSTEM_INSTANCE_NAME variable.

# -----------------------------------------
# Elaborate top level design
alias elab "
vsim -t ps \
     -G/$TOP_LEVEL_NAME/top_level_inst$SYSTEM_INSTANCE_NAME/niosii_system_inst/ram/INIT_FILE=\"c:/lower_level_qsys/software/hello_world_qsys_in_lower_hierachical_level_example/mem_init/ram.hex\" \
     -L work -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cycloneiii_ver $TOP_LEVEL_NAME
"

# -----------------------------------------
# Elaborate the top level design with novopt option
alias elab_debug "
vsim -novopt -t ps \
     -G/$TOP_LEVEL_NAME/top_level_inst$SYSTEM_INSTANCE_NAME/niosii_system_inst/ram/INIT_FILE=\"c:/lower_level_qsys/software/hello_world_qsys_in_lower_hierachical_level_example/mem_init/ram.hex\" \
     -L work -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cycloneiii_ver $TOP_LEVEL_NAME
"

# END CHANGE



# -----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
dev_com
com
elab
"

# -----------------------------------------
# Compile all the design files and elaborate the top level design with -novopt
alias ld_debug "
dev_com
com
elab_debug
"

# -----------------------------------------
# Print out user commmand line aliases
alias h {
echo "List Of Command Line Aliases"
echo 
echo "dev_com                       -- Compile device library files"
echo 
echo "com                           -- Compile the design files in correct order"
echo 
echo "elab                          -- Elaborate top level design"
echo 
echo "elab_debug                    -- Elaborate the top level design with novopt option"
echo 
echo "ld                            -- Compile all the design files and elaborate the top level design"
echo 
echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt"
echo 
echo 
echo 
echo "List Of Variables"
echo 
echo "TOP_LEVEL_NAME                -- Top level module name."
echo 
echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
echo 
echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
}
h

# -----------------------------------------
# Confirm that this is the correct simulation script
echo
echo You edited the correct simulation script.

