// ================================================================================
// (c) 2011 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
// 
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
// 
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
// ================================================================================
// 
// Modified Test Bench for the "Simulating Designs with Lower-Level Qsys Systems" Guide
//	Jeff Wiencrot - 8/2/2011
// 
// This file demonstrates the modifications to the automatically generated Qsys testbench
// that are necessary to accommodate designs in which the Qsys system is not the top level
// entity.  The modifications are marked and explained below with "CHANGE" comments.
//
// This file replaces the automatically generated testbench file which for this guide is
// located in:
//    <project directory>/niosii_system/testbench/niosii_system_tb/simulation/
//
// In general, this file will be located in:
//    <project directory>/<Qsys system name>/testbench/<Qsys system name>_tb/simulation/
// 
// For more information, see "lower_level_qsys.pdf"
// 
// ================================================================================


`timescale 1 ps / 1 ps
module niosii_system_tb (
	);

	wire    niosii_system_inst_clk_bfm_clk_clk;       // niosii_system_inst_clk_bfm:clk -> [niosii_system_inst:clk_clk, niosii_system_inst_reset_bfm:clk]
	wire    niosii_system_inst_reset_bfm_reset_reset; // niosii_system_inst_reset_bfm:reset -> niosii_system_inst:reset_reset_n
	
	// CHANGE: Remove connections to modules that are below the top level module
	//	wire    niosii_system_inst_output_pio_export;     // niosii_system_inst:output_pio_export -> niosii_system_inst_output_pio_bfm:sig_export

	// CHANGE: Remove the instantiation of the Qsys system (which is instantiated by the top level module)
	// niosii_system_tb_niosii_system_inst niosii_system_inst (
	//		.clk_clk           (niosii_system_inst_clk_bfm_clk_clk),       //        clk.clk
	//		.reset_reset_n     (niosii_system_inst_reset_bfm_reset_reset), //      reset.reset_n
	//		.output_pio_export (niosii_system_inst_output_pio_export)      // output_pio.export
	// );

	altera_avalon_clock_source #(
		.CLOCK_RATE (50)
	) niosii_system_inst_clk_bfm (
		.clk (niosii_system_inst_clk_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) niosii_system_inst_reset_bfm (
		.reset (niosii_system_inst_reset_bfm_reset_reset), // reset.reset_n
		.clk   (niosii_system_inst_clk_bfm_clk_clk)        //   clk.clk
	);

	
	// CHANGE: Add instantiation of top level module and necessary connections to test bench.
	wire [7:0] top_level_out;
	top_level top_level_inst (
		.clk		( niosii_system_inst_clk_bfm_clk_clk ),
		.rst_n	( niosii_system_inst_reset_bfm_reset_reset ),
		.out		( top_level_out )
	);
	
	// CHANGE: Remove the instantiation of modules that should be below the top level module
	// niosii_system_tb_niosii_system_inst_output_pio_bfm niosii_system_inst_output_pio_bfm (
	//		.sig_export (niosii_system_inst_output_pio_export)  // conduit.export
	// );

endmodule
