// ================================================================================
// (c) 2011 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
// 
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
// 
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
// ================================================================================
// 
// Top Level Module for the "Simulating Designs with Lower-Level Qsys Systems" Guide
//	Jeff Wiencrot - 8/2/2011
// 
// This module instantiates the lower level Qsys system and the counter module,
// which is controlled by the Qsys system with the output PIO.
// 
// For more information, see "lower_level_qsys.pdf"
// 
// ================================================================================

module top_level
(
	input				clk,
	input				rst_n,
	output	[7:0]	out
);

wire counter_enable;

counter counter_inst (
		.clk			( clk ),
		.rst_n		( rst_n ),
		.enable		( counter_enable ),
		.count		( out )
	);

// For simulation, use this instantiation:
niosii_system_tb_niosii_system_inst niosii_system_inst (
		.clk_clk           ( clk ),					//        clk.clk
		.reset_reset_n     ( rst_n ),					//      reset.reset_n
		.output_pio_export ( counter_enable )		// output_pio.export
	);
	
// For synthesis, use this instantiation:
/*
niosii_system niosii_system_inst (
		.clk_clk           ( clk ),					//        clk.clk
		.reset_reset_n     ( rst_n ),					//      reset.reset_n
		.output_pio_export ( counter_enable )		// output_pio.export
	);
*/
endmodule
